if srb2p return end

//all of the custom variables
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.twirling == nil and player.driftmode == nil and player.driftingtimer == nil and player.driftnboost == nil and player.driftnboosting == nil then
			player.twirling = 0
			player.driftmode = false
			player.driftingtimer = 0
			player.driftnboost = false
			player.driftnboosting = 0
        end
    end
end)

//just for the hud
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.maxdriftingtimer == nil then
			player.maxdriftingtimer = 190
        end
    end
end)

//limit
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.driftingtimer > 190 then
			player.driftingtimer = 190
        end
    end
end)

//Twirl Jump
addHook("AbilitySpecial", function(player)
	if player.mo.skin != "drift"
		return 
	end
	if player.pflags&PF_THOKKED or player.powers[pw_underwater]
		return true
	end
	local dust1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
	local dust2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
	local dust3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
	local dust4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
	local dust5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
	local dust6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
	local dust7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
	local dust8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
	dust1.momx = 8*FRACUNIT
	dust2.momx = -8*FRACUNIT
	dust3.momy = 8*FRACUNIT
	dust4.momy = -8*FRACUNIT
	dust5.momx = 8*FRACUNIT
	dust5.momy = 8*FRACUNIT
	dust6.momx = -8*FRACUNIT
	dust6.momy = 8*FRACUNIT
	dust7.momx = 8*FRACUNIT
	dust7.momy = -8*FRACUNIT
	dust8.momx = -8*FRACUNIT
	dust8.momy = -8*FRACUNIT
	player.mo.state = S_PLAY_GLIDE
	S_StartSound(player.mo, sfx_spin)
	player.pflags = $|PF_THOKKED
	return true
end)

addHook("AbilitySpecial", function(player)
	if player.mo.skin != "drift"
		return 
	end
	if player.pflags&PF_THOKKED
		return true
	end
	local bubble1 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SMALLBUBBLE)
	local bubble2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SMALLBUBBLE)
	local bubble3 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SMALLBUBBLE)
	local bubble4 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SMALLBUBBLE)
	local bubble5 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SMALLBUBBLE)
	local bubble6 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SMALLBUBBLE)
	local bubble7 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SMALLBUBBLE)
	local bubble8 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SMALLBUBBLE)
	bubble1.momx = 8*FRACUNIT
	bubble2.momx = -8*FRACUNIT
	bubble3.momy = 8*FRACUNIT
	bubble4.momy = -8*FRACUNIT
	bubble5.momx = 8*FRACUNIT
	bubble5.momy = 8*FRACUNIT
	bubble6.momx = -8*FRACUNIT
	bubble6.momy = 8*FRACUNIT
	bubble7.momx = 8*FRACUNIT
	bubble7.momy = -8*FRACUNIT
	bubble8.momx = -8*FRACUNIT
	bubble8.momy = -8*FRACUNIT
	player.mo.state = S_PLAY_GLIDE
	S_StartSound(player.mo, sfx_spin)
	player.pflags = $|PF_THOKKED
	return true
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and player.mo.state == S_PLAY_GLIDE then
			P_SetObjectMomZ(player.mo, 6*FRACUNIT, false)
			player.twirling = $+1
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.twirling == 20 then
			player.mo.state = S_PLAY_FALL
			P_SetObjectMomZ(player.mo, -1*FRACUNIT, true)
			player.twirling = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if P_IsObjectOnGround(player.mo) then
			player.twirling = 0
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" 
			if player.mo.state == S_PLAY_GLIDE
				player.powers[pw_strong] = STR_CEILING|STR_ATTACK|STR_WALL|STR_ANIM
			end
		end
	end
end)

//Drifting Boost

//no spindash
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_SKID)
			player.charability2 = CA2_NONE
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and not (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN or player.mo.state == S_PLAY_SKID)
			player.charability2 = CA2_SPINDASH
		end
	end
end)

//start drifting
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN) and ((player.cmd.forwardmove) and (player.cmd.sidemove))
			player.mo.state = S_PLAY_SKID
			player.driftingtimer = $+1
			player.driftmode = true
		end
	end
end)

//drifting
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and player.driftmode == true and ((player.cmd.forwardmove) and (player.cmd.sidemove))
			if ((player.mo.momx > 0 and player.mo.momy > 0) or player.speed > 0)
				player.mo.state = S_PLAY_SKID
				player.driftingtimer = $+1	
			elseif player.speed == 0
				player.driftingtimer = 0
				player.driftmode = false
				P_SetObjectMomZ(player.mo, 1*FRACUNIT)
			end
		end
	end
end)

//tackle enemies with your drift, sometimes it works...
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift"
			if player.mo.state == S_PLAY_SKID
				player.powers[pw_strong] = STR_ATTACK|STR_SPIKE|STR_WALL|STR_ANIM
			end
		end
	end
end)

//when you stop drifting
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and player.driftmode == true and not ((player.cmd.forwardmove) and (player.cmd.sidemove))
			player.mo.state = S_PLAY_STND
			player.driftmode = false
		end
	end
end)

//the boost

//1. nothing
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and player.driftmode == false
			if player.driftingtimer < 35
				player.driftingtimer = 0
			end
		end
	end
end)

//2. mini-turbo
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and player.driftmode == false
			if player.driftingtimer >= 35 and player.driftingtimer < 70
				player.mo.state = S_PLAY_CLIMB
				P_InstaThrust(player.mo, player.mo.angle, 45*FRACUNIT)
				player.normalspeed = 40*FRACUNIT
				player.driftingtimer = 0
				player.driftnboost = true
				player.driftnboosting = 55
				S_StartSound(player.mo, sfx_s23c)
			end
		end
	end
end)

//3. turbo
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and player.driftmode == false
			if player.driftingtimer >= 70 and player.driftingtimer < 125
				player.mo.state = S_PLAY_FLY
				P_InstaThrust(player.mo, player.mo.angle, 49*FRACUNIT)
				player.normalspeed = 45*FRACUNIT
				player.driftingtimer = 0
				player.driftnboost = true
				player.driftnboosting = 70
				S_StartSound(player.mo, sfx_s23c)
			end
		end
	end
end)

//4. super turbo
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and player.driftmode == false
			if player.driftingtimer >= 125 and player.driftingtimer < 190
				player.mo.state = S_PLAY_FLOAT_RUN
				P_InstaThrust(player.mo, player.mo.angle, 55*FRACUNIT)
				player.normalspeed = 50*FRACUNIT
				player.driftingtimer = 0
				player.driftnboost = true
				player.driftnboosting = 85
				S_StartSound(player.mo, sfx_s23c)
			end
		end
	end
end)

//5. ultra turbo
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and player.driftmode == false
			if player.driftingtimer >= 190
				player.mo.state = S_PLAY_DASH
				P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
				player.normalspeed = 55*FRACUNIT
				player.driftingtimer = 0
				player.driftnboost = true
				player.driftnboosting = 100
				player.powers[pw_invulnerability] = 2*TICRATE + 25
				S_StartSound(player.mo, sfx_s23c)
			end
		end
	end
end)

//boosting
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and player.driftnboost == true
			player.driftnboosting = $-1
			player.charflags = $|SF_RUNONWATER
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and player.mo.state == S_PLAY_RUN and player.normalspeed == 40*FRACUNIT
			player.mo.state = S_PLAY_CLIMB
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and player.mo.state == S_PLAY_RUN and player.normalspeed == 45*FRACUNIT
			player.mo.state = S_PLAY_FLY
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and player.mo.state == S_PLAY_RUN and player.normalspeed == 50*FRACUNIT
			player.mo.state = S_PLAY_FLOAT_RUN
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and player.mo.state == S_PLAY_RUN and player.normalspeed == 55*FRACUNIT
			player.mo.state = S_PLAY_DASH
		end
	end
end)

//boost end
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and player.driftnboosting == 0
			player.driftnboost = false
			player.driftnboosting = 0
			player.charflags = SF_STOMPDAMAGE|SF_NOSUPERSPRITES|SF_SUPER|SF_MACHINE|SF_FASTEDGE
			player.normalspeed = 36*FRACUNIT
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift" and (player.mo.state == S_PLAY_CLIMB or player.mo.state == S_PLAY_FLY or player.mo.state == S_PLAY_FLOAT_RUN or player.mo.state == S_PLAY_DASH) and player.driftnboosting == 0
			player.mo.state = S_PLAY_RUN
		end
	end
end)

//boost effects

//the effects
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift"
			if (player.driftingtimer >= 1 and player.driftingtimer < 35)
				P_SpawnSkidDust(player, 4*FRACUNIT, sfx_s3k7e)
			elseif (player.driftingtimer >= 35 and player.driftingtimer < 70)
				P_SpawnSkidDust(player, 4*FRACUNIT, sfx_s3k7e)
				P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_BLUESKIDPARTICLE)
			elseif (player.driftingtimer >= 70 and player.driftingtimer < 125)
				P_SpawnSkidDust(player, 3*FRACUNIT, sfx_s3k7e)
				P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_ORANGESKIDPARTICLE)
			elseif (player.driftingtimer >= 125 and player.driftingtimer < 190)
				P_SpawnSkidDust(player, 2*FRACUNIT, sfx_s3k7e)
				P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_REDSKIDPARTICLE)
			elseif player.driftingtimer > 190
				P_SpawnSkidDust(player, 1*FRACUNIT, sfx_s3k7e)
				P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_PURPLESKIDPARTICLE)
			end
		end
	end
end)

//and the sounds
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "drift"
			if player.driftingtimer == 35
				S_StartSound(player.mo, sfx_hoop1)
				P_SpawnGhostMobj(player.mo)
			elseif (player.driftingtimer == 70)
				S_StartSound(player.mo, sfx_hoop2)
				P_SpawnGhostMobj(player.mo)
				P_SpawnGhostMobj(player.mo)
			elseif (player.driftingtimer == 125)
				S_StartSound(player.mo, sfx_hoop3)
				P_SpawnGhostMobj(player.mo)
				P_SpawnGhostMobj(player.mo)
				P_SpawnGhostMobj(player.mo)
			elseif (player.driftingtimer == 189)
				S_StartSound(player.mo, sfx_ncspec)
				P_SpawnGhostMobj(player.mo)
				P_SpawnGhostMobj(player.mo)
				P_SpawnGhostMobj(player.mo)
				P_SpawnGhostMobj(player.mo)
			end
		end
	end
end)

//additional huds
local function hudstuff(v, player, cam)
	if (player.mo and (player.driftingtimer >= 35 and player.driftingtimer < 70))
		v.drawString(22, 150, "Drift Meter:", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_GRAYMAP|V_PERPLAYER)
		v.drawFill(115, 150, player.maxdriftingtimer/3, 10, SKINCOLOR_BLACK)
		v.drawFill(115, 150, player.driftingtimer/3, 10, SKINCOLOR_SKY)
	end
end

hud.add(hudstuff, player)

local function hudstuff(v, player, cam)
	if (player.mo and (player.driftingtimer >= 70 and player.driftingtimer < 125))
		v.drawString(22, 150, "Drift Meter:", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_GRAYMAP|V_PERPLAYER)
		v.drawFill(115, 150, player.maxdriftingtimer/3, 10, SKINCOLOR_BLACK)
		v.drawFill(115, 150, player.driftingtimer/3, 10, SKINCOLOR_ORANGE)
	end
end

hud.add(hudstuff, player)

local function hudstuff(v, player, cam)
	if (player.mo and (player.driftingtimer >= 125 and player.driftingtimer < 190))
		v.drawString(22, 150, "Drift Meter:", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_GRAYMAP|V_PERPLAYER)
		v.drawFill(115, 150, player.maxdriftingtimer/3, 10, SKINCOLOR_BLACK)
		v.drawFill(115, 150, player.driftingtimer/3, 10, SKINCOLOR_RED)
	end
end

hud.add(hudstuff, player)

local function hudstuff(v, player, cam)
	if (player.mo and player.driftingtimer > 190)
		v.drawString(22, 150, "Drift Meter:", V_SNAPTOBOTTOM|V_SNAPTORIGHT|V_GRAYMAP|V_PERPLAYER)
		v.drawFill(115, 150, player.maxdriftingtimer/3, 10, SKINCOLOR_BLACK)
		v.drawFill(115, 150, player.driftingtimer/3, 10, SKINCOLOR_PURPLE)
	end
end

hud.add(hudstuff, player)