if srb2p return end

//all of the custom variables
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.ressorting == nil and player.ressorttimer == nil and player.ressortmode == nil then
			player.ressorting = false
			player.ressorttimer = 0
			player.ressortmode = false
        end
    end
end)

//just for the hud
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.maxressorttimer == nil then
			player.maxressorttimer = 4*TICRATE
        end
    end
end)

//limit
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.ressorttimer > 4*TICRATE then
			player.ressorttimer = 4*TICRATE
        end
    end
end)

//start ressort
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "ressort" and (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT or player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN) and (player.cmd.buttons & BT_SPIN)
			P_InstaThrust(player.mo, player.mo.angle, -13*FRACUNIT)
			player.ressorting = true
		end
	end
end)

//ressorting
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "ressort" and player.ressorting == true and (player.cmd.buttons & BT_SPIN)
			P_InstaThrust(player.mo, player.mo.angle, -13*FRACUNIT)
			player.ressorttimer = $+4
		end
	end
end)

//when you stop ressorting
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "ressort" and player.ressorting == true and not (player.cmd.buttons & BT_SPIN)
			player.mo.state = S_PLAY_DASH
			player.ressorting = false
		end
	end
end)

//the boost
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "ressort" and player.ressorting == false and player.ressorttimer > 0 and not player.ressortmode == true
			player.ressortmode = true
			P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
			S_StartSound(player.mo, sfx_spin)
		end
	end
end)

//boosting
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "ressort" and player.ressortmode == true
			player.ressorttimer = $-1
			player.thrustfactor = 7
			player.accelstart = 100
			player.acceleration = 43
			player.normalspeed = 53*FRACUNIT
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "ressort" and player.mo.state == S_PLAY_RUN and player.ressortmode == true
			player.mo.state = S_PLAY_DASH
		end
	end
end)

//effects
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "ressort"
			if player.mo.state == S_PLAY_DASH
				player.powers[pw_strong] = STR_ATTACK|STR_SPIKE|STR_WALL|STR_ANIM
				P_SpawnMobjFromMobj(player.mo, 0 ,0, 6*FRACUNIT, MT_SMOKE)
			end
		end
	end
end)

//boost end
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "ressort" and player.ressorttimer == 0
			player.ressortmode = false
			player.ressorttimer = 0
			player.thrustfactor = 6
			player.accelstart = 99
			player.acceleration = 40
			player.normalspeed = 36*FRACUNIT
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "ressort" and player.mo.state == S_PLAY_DASH and player.ressorttimer == 0
			player.mo.state = S_PLAY_RUN
		end
	end
end)

//sound
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.mo.skin == "ressort"
			if (player.ressorttimer == 3*TICRATE+30)
				S_StartSound(player.mo, sfx_ncspec)
				P_SpawnGhostMobj(player.mo)
				P_SpawnGhostMobj(player.mo)
				P_SpawnGhostMobj(player.mo)
				P_SpawnGhostMobj(player.mo)
			end
		end
	end
end)

//additional hud
local function hudstuff(v, player, cam)
	if (player.mo and player.mo.skin == "ressort" and (player.ressortmode == true or player.ressorttimer > 0))
		v.drawFill(180, 130, player.maxressorttimer/3, 8, SKINCOLOR_GREY)
		v.drawFill(180, 129, player.ressorttimer/3, 10, SKINCOLOR_WHITE)
	end
end

hud.add(hudstuff, player)