freeslot("sfx_stunt")

sfxinfo[sfx_stunt].caption = "Stunt"

//the custom variable
addHook("ThinkFrame", function()
    for player in players.iterate do
        if player.botstunt == nil then
			player.botstunt = 0
        end
    end
end)

//the stunt
addHook("ThinkFrame", function()
    for player in players.iterate do
        if (player.mo.skin == "drift" or player.mo.skin == "ressort") and (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL) and player.botstunt == 0 and (player.cmd.buttons & BT_SPIN) and not (player.pflags & PF_JUMPED)
			player.botstunt = 1
			local stunts = P_RandomRange(1,5)
			if stunts == 1
				player.mo.state = S_PLAY_TWINSPIN
				player.powers[pw_invulnerability] = 10
				S_StartSound(player.mo, sfx_stunt)
			elseif stunts == 2
				player.mo.state = S_PLAY_FIRE
				player.powers[pw_invulnerability] = 10
				S_StartSound(player.mo, sfx_stunt)
			elseif stunts == 3
				player.mo.state = S_PLAY_PAIN
				player.powers[pw_invulnerability] = 10
				S_StartSound(player.mo, sfx_stunt)
			elseif stunts == 4
				player.mo.state = S_PLAY_DRWN
				player.powers[pw_invulnerability] = 10
				S_StartSound(player.mo, sfx_stunt)
			elseif stunts == 5
				player.mo.state = S_PLAY_WALK
				player.powers[pw_invulnerability] = 10
				S_StartSound(player.mo, sfx_stunt)
			end
		end
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if (player.mo.skin == "drift" or player.mo.skin == "ressort") and P_IsObjectOnGround(player.mo) and player.botstunt == 1
			player.botstunt = 0
			P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT)
			P_SpawnSkidDust(player, 2*FRACUNIT)
			P_SpawnSkidDust(player, 1*FRACUNIT)
			P_SpawnSkidDust(player, 2*FRACUNIT)
			P_SpawnSkidDust(player, 3*FRACUNIT)
			player.powers[pw_sneakers] = 8
			S_StartSound(player.mo, sfx_zoom)
		end
	end
end)